<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
    "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en">
<!-- Source/Synopsis/Formatters/HTML/Views/ModuleTree.py.html -->
<!-- this view was generated by Source -->
<head>
<meta content="text/html; charset=iso-8859-1" http-equiv="Content-Type"/>
<title >Synopsis - Synopsis/Formatters/HTML/Views/ModuleTree.py</title>
<link href="../../../../../style.css" type="text/css" rel="stylesheet" />
</head>
<body class="Source">
<div class="navigation">
<span class="normal"><a href="../../../../../Scopes/Synopsis.html" >Global Package</a></span>
<span class="normal"><a href="../../../../../InheritanceTree.html" >Inheritance Tree</a></span>
<span class="normal"><a href="../../../../../InheritanceGraph.html" >Inheritance Graph</a></span>
<span class="normal"><a href="../../../../../NameIndex.html" >Name Index</a></span>
</div>
File: <b >Synopsis/Formatters/HTML/Views/ModuleTree.py</b><pre class="sxr"><a id="line1"></a><span class="lineno"> 1</span><span class="line"><span class="py-comment">#</span></span>
<a id="line2"></a><span class="lineno"> 2</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stephen Davies</span></span>
<a id="line3"></a><span class="lineno"> 3</span><span class="line"><span class="py-comment"># Copyright (C) 2000 Stefan Seefeld</span></span>
<a id="line4"></a><span class="lineno"> 4</span><span class="line"><span class="py-comment"># All rights reserved.</span></span>
<a id="line5"></a><span class="lineno"> 5</span><span class="line"><span class="py-comment"># Licensed to the public under the terms of the GNU LGPL (&gt;= 2),</span></span>
<a id="line6"></a><span class="lineno"> 6</span><span class="line"><span class="py-comment"># see the file COPYING for details.</span></span>
<a id="line7"></a><span class="lineno"> 7</span><span class="line"><span class="py-comment">#</span></span>
<a id="line8"></a><span class="lineno"> 8</span>
<a id="line9"></a><span class="lineno"> 9</span><span class="line"><span class="py-keyword">from</span> Synopsis <span class="py-keyword">import</span> ASG</span>
<a id="line10"></a><span class="lineno">10</span><span class="line"><span class="py-keyword">from</span> Synopsis.Formatters.HTML.Tags <span class="py-keyword">import</span> *</span>
<a id="line11"></a><span class="lineno">11</span><span class="line"><span class="py-keyword">from</span> Tree <span class="py-keyword">import</span> Tree</span>
<a id="line12"></a><span class="lineno">12</span>
<a id="line13"></a><span class="lineno">13</span><span class="line"><span class="py-keyword">class</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html">ModuleTree</a>(Tree):</span>
<a id="line14"></a><span class="lineno">14</span><span class="line">    <span class="py-string">&quot;&quot;&quot;Create a javascript-enabled module tree.&quot;&quot;&quot;</span></span>
<a id="line15"></a><span class="lineno">15</span>
<a id="line16"></a><span class="lineno">16</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#register">register</a>(self, frame):</span>
<a id="line17"></a><span class="lineno">17</span>
<a id="line18"></a><span class="lineno">18</span><span class="line">        super(ModuleTree, self).register(frame)</span>
<a id="line19"></a><span class="lineno">19</span><span class="line">        self._children_cache = {}</span>
<a id="line20"></a><span class="lineno">20</span>
<a id="line21"></a><span class="lineno">21</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#filename">filename</a>(self):</span>
<a id="line22"></a><span class="lineno">22</span>
<a id="line23"></a><span class="lineno">23</span><span class="line">        <span class="py-keyword">if</span> self.main:</span>
<a id="line24"></a><span class="lineno">24</span><span class="line">            <span class="py-keyword">return</span> self.directory_layout.index()</span>
<a id="line25"></a><span class="lineno">25</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line26"></a><span class="lineno">26</span><span class="line">            <span class="py-keyword">return</span> self.directory_layout.special(<span class="py-string">'ModuleTree'</span>)</span>
<a id="line27"></a><span class="lineno">27</span>
<a id="line28"></a><span class="lineno">28</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#title">title</a>(self):</span>
<a id="line29"></a><span class="lineno">29</span>
<a id="line30"></a><span class="lineno">30</span><span class="line">        <span class="py-keyword">return</span> <span class="py-string">'Module Tree'</span></span>
<a id="line31"></a><span class="lineno">31</span>
<a id="line32"></a><span class="lineno">32</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#root">root</a>(self):</span>
<a id="line33"></a><span class="lineno">33</span>
<a id="line34"></a><span class="lineno">34</span><span class="line">        <span class="py-keyword">return</span> self.filename(), self.title()</span>
<a id="line35"></a><span class="lineno">35</span>
<a id="line36"></a><span class="lineno">36</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#process">process</a>(self):</span>
<a id="line37"></a><span class="lineno">37</span>
<a id="line38"></a><span class="lineno">38</span><span class="line">        self.start_file()</span>
<a id="line39"></a><span class="lineno">39</span><span class="line">        self.write_navigation_bar()</span>
<a id="line40"></a><span class="lineno">40</span><span class="line">        module = self.processor.root</span>
<a id="line41"></a><span class="lineno">41</span><span class="line">        self.index_module(module, module.name)</span>
<a id="line42"></a><span class="lineno">42</span><span class="line">        self.end_tree()</span>
<a id="line43"></a><span class="lineno">43</span><span class="line">        self.end_file()</span>
<a id="line44"></a><span class="lineno">44</span>
<a id="line45"></a><span class="lineno">45</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#_link_href">_link_href</a>(self, module):</span>
<a id="line46"></a><span class="lineno">46</span>
<a id="line47"></a><span class="lineno">47</span><span class="line">        <span class="py-keyword">return</span> self.directory_layout.module_index(module.name)</span>
<a id="line48"></a><span class="lineno">48</span>
<a id="line49"></a><span class="lineno">49</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#get_children">get_children</a>(self, decl):</span>
<a id="line50"></a><span class="lineno">50</span>
<a id="line51"></a><span class="lineno">51</span><span class="line">        <span class="py-keyword">try</span>: <span class="py-keyword">return</span> self._children_cache[decl]</span>
<a id="line52"></a><span class="lineno">52</span><span class="line">        <span class="py-keyword">except</span> KeyError: <span class="py-keyword">pass</span></span>
<a id="line53"></a><span class="lineno">53</span><span class="line">        children = [c <span class="py-keyword">for</span> c <span class="py-keyword">in</span> decl.declarations <span class="py-keyword">if</span> isinstance(c, ASG.Module)]</span>
<a id="line54"></a><span class="lineno">54</span><span class="line">        self._children_cache[decl] = children</span>
<a id="line55"></a><span class="lineno">55</span><span class="line">        <span class="py-keyword">return</span> children</span>
<a id="line56"></a><span class="lineno">56</span>
<a id="line57"></a><span class="lineno">57</span><span class="line">    <span class="py-keyword">def</span> <a href="../../../../../Scopes/Synopsis/Formatters/HTML/Views/ModuleTree/ModuleTree.html#index_module">index_module</a>(self, module, qname):</span>
<a id="line58"></a><span class="lineno">58</span><span class="line">        <span class="py-string">&quot;&quot;&quot;Write a link for this module and recursively visit child modules.&quot;&quot;&quot;</span></span>
<a id="line59"></a><span class="lineno">59</span>
<a id="line60"></a><span class="lineno">60</span><span class="line">        <span class="py-comment"># Find children, and sort so that compound children (packages) go first</span></span>
<a id="line61"></a><span class="lineno">61</span><span class="line">        children = self.get_children(module)</span>
<a id="line62"></a><span class="lineno">62</span><span class="line">        children.sort(<span class="py-keyword">lambda</span> a,b,g=self.get_children:</span>
<a id="line63"></a><span class="lineno">63</span><span class="line">                      cmp(len(g(b)),len(g(a))))</span>
<a id="line64"></a><span class="lineno">64</span><span class="line">        <span class="py-comment"># Print link to this module</span></span>
<a id="line65"></a><span class="lineno">65</span><span class="line">        <span class="py-keyword">if</span> module.name:</span>
<a id="line66"></a><span class="lineno">66</span><span class="line">            label = str(qname.prune(module.name))</span>
<a id="line67"></a><span class="lineno">67</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line68"></a><span class="lineno">68</span><span class="line">            label = <span class="py-string">'Global %s'</span>%module.type.capitalize()</span>
<a id="line69"></a><span class="lineno">69</span><span class="line">        link = self._link_href(module)</span>
<a id="line70"></a><span class="lineno">70</span><span class="line">        text = href(link, label, target=<span class="py-string">'detail'</span>)</span>
<a id="line71"></a><span class="lineno">71</span><span class="line">        <span class="py-keyword">if</span> <span class="py-keyword">not</span> len(children):</span>
<a id="line72"></a><span class="lineno">72</span><span class="line">            self.write_leaf(text)</span>
<a id="line73"></a><span class="lineno">73</span><span class="line">        <span class="py-keyword">else</span>:</span>
<a id="line74"></a><span class="lineno">74</span><span class="line">            self.write_node_start(text)</span>
<a id="line75"></a><span class="lineno">75</span><span class="line">            <span class="py-comment"># Add children</span></span>
<a id="line76"></a><span class="lineno">76</span><span class="line">            <span class="py-keyword">for</span> child <span class="py-keyword">in</span> children:</span>
<a id="line77"></a><span class="lineno">77</span><span class="line">                self.index_module(child, module.name)</span>
<a id="line78"></a><span class="lineno">78</span><span class="line">            self.write_node_end()</span>
<a id="line79"></a><span class="lineno">79</span>
<a id="line80"></a><span class="lineno">80</span>
</pre>
<div class="logo">Generated on Thu Apr 16 16:27:15 2009 by 
<br/>
<a href="http://synopsis.fresco.org" target="_blank"><img src="../../../../../synopsis.png" alt="logo"/> synopsis</a> (version devel)</div>
</body>
</html>
